;-------------------------------------------------------;
;                   the BOS kernel                      ;
;-------------------------------------------------------;
;    The BOS 32-bit kernel, expects to be loaded at     ;
;         1mb, a20 enabled.                             ;
;                                                       ;
;      For any comments on this code, mail me:          ;
;               bubach85@hotmail.com                    ;
;                                                       ;
;             by: Christoffer Bubach, 2003-2005         ;
;-------------------------------------------------------;
use32
org 0x10000

;---------------------------;
;  jumo to starting point   ;
;---------------------------;
	  jmp	  start


;----------------------------------------;
;      include files                     ;
;----------------------------------------;
	  include  'krl_incs/text.inc'		      ; The default textmode driver.
	  include  'krl_incs/bos_init.inc'	      ; Function that starts up BOS
	  include  'krl_incs/en_mess.inc'	      ; All strings in english
	  include  'krl_incs/gdt.inc'		      ; The Global Description Table.
	  include  'krl_incs/pic.inc'		      ; PIC rutines.
	  include  'krl_incs/sys_ints.inc'	      ; System specific interrupts.
	  include  'krl_incs/keyboard.inc'	      ; Keyboard ISR.
	  include  'krl_incs/keymap.inc'	      ; Keymap(s).
	  include  'krl_incs/shell.inc' 	      ; File with shell/kernel monitor functions.
	  include  'krl_incs/commands.inc'	      ; Command table, for valid shell commands.
	  include  'krl_incs/isr.inc'		      ; Interrupt Service Rutines.
	  include  'krl_incs/idt.inc'		      ; The Interrupt Description Table.
	  include  'krl_incs/debug.inc' 	      ; Print contents of all regs and hang.


;----------------------------------------;
;  starting point of BOS kernel code..   ;
;----------------------------------------;
start:



     ;-------------------------------;
     ;  set new GDT and registers    ;
     ;-------------------------------;
	  lgdt	  [gdtr]

	  mov	  ax, datasel
	  mov	  ds, ax
	  mov	  fs, ax
	  mov	  gs, ax
	  mov	  es, ax
	  mov	  ss, ax
	  mov	  esp, 0x90000

	  jmp	  codesel:.new_cs
     .new_cs:


     ;-----------------------------;
     ;  should fix everything...   ;
     ;-----------------------------;
	  call	  bos_init


;---------------;
;  other.....   ;
;---------------;

     ;-------------------;
     ;  init "shell"     ;
     ;-------------------;
	  mov	  bx, 0x04B1
	  call	  setcursor
	  mov	  esi, bos_shell
	  mov	  al, 0x07
	  call	  print
	  call	  init_cmd
	  jmp	  shell

     ;-------------------------;
     ;  hang, just in case..   ;
     ;-------------------------;
	  jmp	  $				      ; Main loop.. ;-)