;----------------------------------------------------------;
; BOS                            Christoffer Bubach, 2004. ;
;----------------------------------------------------------;
;                                                          ;
;     Initiation function for BOS                          ;
;                                                          ;
;----------------------------------------------------------;



;------------------;
;  init BOS 0.03   ;
;------------------;
bos_init:

     ;----------------------;
     ;  we are in pmode..   ;
     ;----------------------;
	  mov	  bx, 0x0193
	  call	  setcursor
	  mov	  esi, pmode_load
	  mov	  al, 0x07
	  call	  print

	  mov	  bx, 0x01C5
	  call	  setcursor
	  mov	  esi, pmode_load_ok
	  mov	  al, 0x02
	  call	  print

     ;----------------------;
     ;   kernel loaded..    ;
     ;----------------------;
	  mov	  bx, 0x01E3
	  call	  setcursor
	  mov	  esi, kernel_load
	  mov	  al, 0x07
	  call	  print

	  mov	  bx, 0x0215
	  call	  setcursor
	  mov	  esi, kernel_load_ok
	  mov	  al, 0x02
	  call	  print

     ;----------------;
     ;  remap PICs    ;
     ;----------------;
	  mov	  cl, 0x20			      ; PIC 1, irq0-irq7 -> int 0x20-27.
	  mov	  ch, 0x28			      ; PIC 2, irq8-irq15 -> int 0x28-30.
	  call	  remap_pics
	  call	  disable_irqs

	  mov	  bx, 0x0233
	  call	  setcursor
	  mov	  esi, pic_irq
	  mov	  al, 0x07
	  call	  print

	  mov	  bx, 0x0265
	  call	  setcursor
	  mov	  esi, pic_irq_ok
	  mov	  al, 0x02
	  call	  print

     ;--------------;
     ;  setup IDT   ;
     ;--------------;
	  lidt	  [idt_pointer]

	  sti					      ; Interrupts back..

	  mov	  bx, 0x0283
	  call	  setcursor
	  mov	  esi, idt
	  mov	  al, 0x07
	  call	  print

	  mov	  bx, 0x02B5
	  call	  setcursor
	  mov	  esi, idt_ok
	  mov	  al, 0x02
	  call	  print


     ;---------------------------------------------;
     ;  enable IRQs (one after one as i code it)   ;
     ;---------------------------------------------;
	  mov	  cl, 1
	  call	  enable_irq			      ; Enable IRQ 1.

	  mov	  bx, 0x02D3
	  call	  setcursor
	  mov	  esi, kbd_load
	  mov	  al, 0x07
	  call	  print

	  mov	  bx, 0x0305
	  call	  setcursor
	  mov	  esi, kbd_ok
	  mov	  al, 0x02
	  call	  print

     ;-------------------------;
     ;  return to kernel.asm   ;
     ;-------------------------;
	  ret