;----------------------------------------------------------;
; BOS 0.03                  Christoffer Bubach, 2004-2005. ;
;----------------------------------------------------------;
;                                                          ;
;  Command table and some commands for the shell.          ;
;                                                          ;
;----------------------------------------------------------;

	  commands:	  db   'ver', 0
			  db   'help', 0
			  db   '?', 0
			  db   'about', 0
			  db   'cls', 0
			  db   'clrscr', 0
			  db   'reboot', 0
			  db   'dump', 0
			  db   0xFF		      ; end of command table


	  call_table:	  dd   show_ver 	      ; commands.inc
			  dd   show_help	      ; commands.inc
			  dd   show_help	      ; commands.inc
			  dd   show_about	      ; commands.inc
			  dd   clrscr		      ; commands.inc
			  dd   clrscr		      ; comamnds.inc
			  dd   reboot		      ; commands.inc
			  dd   dump_regs	      ; debug.inc




     ;--------------------------;
     ;   not a valid command    ;
     ;--------------------------;
	 not_a_valid_cmd  db   13,10,'Unknown command or bad file name!', 0
     no_such_cmd:
	  push	  esi
	  push	  ax

	  mov	  esi, not_a_valid_cmd
	  mov	  al, 0x04
	  call	  print

	  pop	  ax
	  pop	  esi
	  ret


     ;-------------------;
     ;   show version    ;
     ;-------------------;
	  bos_ver_str	  db   13,10,'BCOS version 0.05 by Sean Streeter.', 0
     show_ver:
	  push	  esi
	  push	  ax

	  mov	  esi, bos_ver_str
	  mov	  al, 0x07
	  call	  print

	  pop	  ax
	  pop	  esi
	  ret


     ;--------------------;
     ;   show BOS help    ;
     ;--------------------;
	  bos_help_str	  db   13,10,13,10,' Black Cat OS 0.05 by Sean Streeter.',13,10,\
			       '---------------------------------------',13,10,\
			       'Type a command and press ENTER to execute it.',13,10,\
			       'Valid commands are:',13,10,13,10,\
			       '"help" or "?"       - Displays this text.',13,10,\
			       '"ver"               - Shows version information.',13,10,\
			       '"about"             - Shows information about the OS.',13,10,\
			       '"cls" or "clrscr"   - Clears the screen.',13,10,\
			       '"dump"              - Dump some standard registers.',13,10,\
			       '"reboot"            - Restarts the computer.',13,10,13,10,\
			       ' ',0
     show_help:
	  push	  esi
	  push	  ax

	  mov	  esi, bos_help_str
	  mov	  al, 0x07
	  call	  print

	  pop	  ax
	  pop	  esi
	  ret


     ;-----------------;
     ;   show about    ;
     ;-----------------;
	  bos_about_str   db   13,10,'About BCOS',13,10,\
			       'Black Cat OS (Black Cat OS)',13,10,13,10,\
			       'By: Sean Streeter',13,10,\
			       '    E-mail: anubis2591@gmail.com',13,10,\
			       'Orignal By: Christoffer Bubach',13,10,\
			       'Visit www.geocities.com/bcos0 for more info',0
     show_about:
	  push	  esi
	  push	  ax

	  mov	  esi, bos_about_str
	  mov	  al, 0x07
	  call	  print

	  pop	  ax
	  pop	  esi
	  ret


     ;-----------------------;
     ;   clear the screen    ;
     ;-----------------------;
     clrscr:
	  call	  cls				      ; text.inc
	  mov	  esi, prompt
	  mov	  al, 0x07
	  call	  print
	  mov	  edi, cmd_buffer
	  jmp	  shell 			      ; no normal return, as it gives an extra line feed


     ;-------------;
     ;   reboot    ;
     ;-------------;
     reboot:
	  call	  kbd_wait
	  mov	  al, 0xFE
	  out	  0x64, al
	  jmp	  $
	  ret


     ;-----------------;
     ;   make error    ;
     ;-----------------;
     make_error:

	  ret