;----------------------------------------------------------;
; BOS 0.03                       Christoffer Bubach, 2004. ;
;----------------------------------------------------------;
;                                                          ;
;   IDT (Interrupt Description Table)                      ;
;                                                          ;
;----------------------------------------------------------;



;-----------------;
;  IDT pointer    ;
;-----------------;
idt_pointer:
	  dw idt_end - idt_start - 1
	  dd idt_start



;----------------;
;   IDT          ;
;----------------;
idt_start:

     ;---------------------;
     ; 0. Interrupt 0x00   ;
     ;---------------------;
	  dw (isr00 and 0xFFFF) 		      ; Note: in nasm its "&" instead of "and"
	  dw codesel
	  db 0
	  db 0x8E
	  dw (isr00 shr 16)			      ; nasm: "<<" instead of "shr"

     ;---------------------;
     ; 1. Interrupt 0x01.  ;
     ;---------------------;
	  dw (isr01 and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (isr01 shr 16)

     ;---------------------;
     ; 2. Interrupt 0x02.  ;
     ;---------------------;
	  dw (isr02 and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (isr02 shr 16)

     ;---------------------;
     ; 3. Interrupt 0x03.  ;
     ;---------------------;
	  dw (isr03 and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (isr03 shr 16)

     ;---------------------;
     ; 4. Interrupt 0x04.  ;
     ;---------------------;
	  dw (isr04 and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (isr04 shr 16)

     ;---------------------;
     ; 5. Interrupt 0x05.  ;
     ;---------------------;
	  dw (isr05 and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (isr05 shr 16)

     ;---------------------;
     ; 6. Interrupt 0x06.  ;
     ;---------------------;
	  dw (isr06 and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (isr06 shr 16)

     ;---------------------;
     ; 7. Interrupt 0x07.  ;
     ;---------------------;
	  dw (isr07 and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (isr07 shr 16)

     ;---------------------;
     ; 8. Interrupt 0x08.  ;
     ;---------------------;
	  dw (isr08 and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (isr08 shr 16)

     ;---------------------;
     ; 9. Interrupt 0x09.  ;
     ;---------------------;
	  dw (isr09 and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (isr09 shr 16)

     ;---------------------;
     ; 10. Interrupt 0x0A. ;
     ;---------------------;
	  dw (isr0A and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (isr0A shr 16)

     ;---------------------;
     ; 11. Interrupt 0x0B. ;
     ;---------------------;
	  dw (isr0B and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (isr0B shr 16)

     ;---------------------;
     ; 12. Interrupt 0x0C. ;
     ;---------------------;
	  dw (isr0C and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (isr0C shr 16)

     ;---------------------;
     ; 13. Interrupt 0x0D. ;
     ;---------------------;
	  dw (isr0D and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (isr0D shr 16)

     ;---------------------;
     ; 14. Interrupt 0x0E. ;
     ;---------------------;
	  dw (isr0E and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (isr0E shr 16)

     ;---------------------;
     ; 15. Interrupt 0x0F. ;
     ;---------------------;
	  dw (u_isr and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (u_isr shr 16)

     ;---------------------;
     ; 16. Interrupt 0x10. ;
     ;---------------------;
	  dw (isr10 and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (isr10 shr 16)

     ;---------------------;
     ; 17. Interrupt 0x11. ;
     ;---------------------;
	  dw (isr11 and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (isr11 shr 16)

     ;---------------------;
     ; 18. Interrupt 0x12. ;
     ;---------------------;
	  dw (isr12 and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (isr12 shr 16)

     ;---------------------;
     ; 19. Interrupt 0x13. ;
     ;---------------------;
	  dw (isr13 and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (isr13 shr 16)

     ;---------------------;
     ; 20. Interrupt 0x14. ;
     ;---------------------;
	  dw (u_isr and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (u_isr shr 16)

     ;---------------------;
     ; 21. Interrupt 0x15. ;
     ;---------------------;
	  dw (u_isr and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (u_isr shr 16)

     ;---------------------;
     ; 22. Interrupt 0x16. ;
     ;---------------------;
	  dw (u_isr and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (u_isr shr 16)

     ;---------------------;
     ; 23. Interrupt 0x17. ;
     ;---------------------;
	  dw (u_isr and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (u_isr shr 16)

     ;---------------------;
     ; 24. Interrupt 0x18. ;
     ;---------------------;
	  dw (u_isr and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (u_isr shr 16)

     ;---------------------;
     ; 25. Interrupt 0x19. ;
     ;---------------------;
	  dw (u_isr and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (u_isr shr 16)

     ;---------------------;
     ; 26. Interrupt 0x1A. ;
     ;---------------------;
	  dw (u_isr and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (u_isr shr 16)

     ;---------------------;
     ; 27. Interrupt 0x1B. ;
     ;---------------------;
	  dw (u_isr and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (u_isr shr 16)

     ;---------------------;
     ; 28. Interrupt 0x1C. ;
     ;---------------------;
	  dw (u_isr and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (u_isr shr 16)

     ;---------------------;
     ; 29. Interrupt 0x1D. ;
     ;---------------------;
	  dw (u_isr and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (u_isr shr 16)

     ;---------------------;
     ; 30. Interrupt 0x1E. ;
     ;---------------------;
	  dw (u_isr and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (u_isr shr 16)

     ;---------------------;
     ; 31. Interrupt 0x1F. ;
     ;---------------------;
	  dw (u_isr and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (u_isr shr 16)

     ;---------------------;
     ; 32. Interrupt 0x20. ;
     ;---------------------;
	  dw (isr20 and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (isr20 shr 16)

     ;---------------------;
     ; 33. Interrupt 0x21. ;
     ;---------------------;
	  dw (isr21 and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (isr21 shr 16)

     ;---------------------;
     ; 34. Interrupt 0x22. ;
     ;---------------------;
	  dw (u_isr and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (u_isr shr 16)

     ;---------------------;
     ; 35. Interrupt 0x23. ;
     ;---------------------;
	  dw (u_isr and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (u_isr shr 16)

     ;---------------------;
     ; 36. Interrupt 0x24. ;
     ;---------------------;
	  dw (u_isr and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (u_isr shr 16)

     ;---------------------;
     ; 37. Interrupt 0x25. ;
     ;---------------------;
	  dw (u_isr and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (u_isr shr 16)

     ;---------------------;
     ; 38. Interrupt 0x26. ;
     ;---------------------;
	  dw (u_isr and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (u_isr shr 16)

     ;---------------------;
     ; 39. Interrupt 0x27. ;
     ;---------------------;
	  dw (u_isr and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (u_isr shr 16)

     ;---------------------;
     ; 40. Interrupt 0x28. ;
     ;---------------------;
	  dw (u_isr and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (u_isr shr 16)

     ;---------------------;
     ; 41. Interrupt 0x29. ;
     ;---------------------;
	  dw (u_isr and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (u_isr shr 16)

     ;---------------------;
     ; 42. Interrupt 0x2A. ;
     ;---------------------;
	  dw (u_isr and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (u_isr shr 16)

     ;---------------------;
     ; 43. Interrupt 0x2B. ;
     ;---------------------;
	  dw (u_isr and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (u_isr shr 16)

     ;---------------------;
     ; 44. Interrupt 0x2C. ;
     ;---------------------;
	  dw (u_isr and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (u_isr shr 16)

     ;---------------------;
     ; 45. Interrupt 0x2D. ;
     ;---------------------;
	  dw (u_isr and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (u_isr shr 16)

     ;---------------------;
     ; 46. Interrupt 0x2E. ;
     ;---------------------;
	  dw (u_isr and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (u_isr shr 16)

     ;---------------------;
     ; 47. Interrupt 0x2F. ;
     ;---------------------;
	  dw (u_isr and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (u_isr shr 16)

     ;---------------------;
     ; 48. Interrupt 0x30. ;
     ;---------------------;
	  dw (u_isr and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (u_isr shr 16)

     ;---------------------;
     ; 49. Interrupt 0x31. ;
     ;---------------------;
	  dw (u_isr and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (u_isr shr 16)

     ;---------------------;
     ; 50. Interrupt 0x32. ;
     ;---------------------;
	  dw (isr32 and 0xFFFF)
	  dw codesel
	  db 0
	  db 0x8E
	  dw (isr32 shr 16)


idt_end: